#include "Message.hpp"

void Message::add_data(float value, int identifier)
{
	if (data.amountData < NUM_SENSORS) {
		data.values[data.amountData] = value;
		data.identifiers[data.amountData] = identifier;
		data.amountData++;
	}
}

esp_err_t Message::send()
{
	Serial.println("sending Message");
	esp_err_t success;
	success = esp_now_send(recipient, (uint8_t *)&data, sizeof(data));
	// if(success != ESP_OK){
	//     if(!ram_cache_is_full()){
	//         ram_cache_push(*data);
	//     }
	// }
	for (int i = 0; i < data.amountData; i++) {
		Serial.println(data.values[i]);
	}
	Serial.println((String) "time sent: " + data.timestamp);
	Serial.println((String) "Send status: " + success);
	Serial.println();
	Serial.println("done");
	Serial.flush();
	return success;
}

Message ::Message()
{
	// check for existing host mac address, use broadcast otherwise
	get_host_mac(recipient);

	data.amountData = 0;
	data.timestamp = esptime::rtc.getMillis(); // I am assuming we are not sending data from Unix Epoch
}

Message ::Message(ClientDataPackage old_data)
{
	data = old_data;
	// memcpy(&data, &old_data, sizeof(data));
	get_host_mac(recipient);
}