#include "ESPNow.hpp"
#include "ram_caching.hpp"
#include <Arduino.h>
#include <ArduinoJson.h>
#include "Time.hpp"

void setup()
{

	// put your setup code here, to run once:
	Serial.begin(115200);
	while (!Serial)
		;
	Serial.flush();

	esp_err_t result = espnow_setup();

	esptime::rtc = ESP32Time();

	StaticJsonDocument<96> doc;

	doc["sensor"] = "gps";
	doc["time"] = 1351824120;

	JsonArray data = doc.createNestedArray("data");
	data.add(48.75608);
	data.add(2.302038);
}

int counter = 0;

void loop()
{
	// put your main code here, to run repeatedly:
	Message new_data = Message{};
	new_data.add_data(++counter * 1.1, 0);
	new_data.add_data(counter * 1.2, 1);
	new_data.add_data(counter * 1.3, 2);
	new_data.send();

	// if(!ram_cache_is_empty()){
	//   ClientDataPackage old_data = ram_cache_pop();
	//   Message* resend_message = new Message(old_data);
	//   resend_message->send();
	//   delete resend_message;
	// }
	Serial.println(esptime::rtc.getMillis());
	Serial.println("delaying...");
	Serial.flush();
	delay(5000);
}